Search documentation of stdlib

# View Source erl_lint (stdlib v6.0.1)

The Erlang code linter.

This module is used to check Erlang code for illegal syntax and other bugs. It also warns against coding practices that are not recommended.

The errors detected include:

- Redefined and undefined functions
- Unbound and unsafe variables
- Illegal record use

The warnings detected include:

- Unused functions and imports
- Unused variables
- Variables imported into matches
- Variables exported from `if`/`case`/`receive`
- Variables shadowed in funs and list comprehensions

Some of the warnings are optional, and can be turned on by specifying the appropriate option, described below.

The functions in this module are invoked automatically by the Erlang compiler. There is no reason to invoke these functions separately unless you have written your own Erlang compiler.

## Error Information

`ErrorInfo` is the standard `ErrorInfo` structure that is returned from all I/O modules. The format is as follows:

    {ErrorLine, Module, ErrorDescriptor}

A string describing the error is obtained with the following call:

    Module:format_error(ErrorDescriptor)

## See Also

`epp`, `erl_parse`

# Summary

## Types

error_description()
error_info()
fa()
fun_used_vars()

## Functions

format_error(ErrorDescriptor)

Takes an `ErrorDescriptor` and returns a string that describes the error or warning. This function is usually called implicitly when processing an `ErrorInfo` structure (see section Error Information).

is_guard_test(Expr)

Tests if `Expr` is a legal guard test. `Expr` is an Erlang term representing the abstract form for the expression. `erl_parse:parse_exprs(Tokens)` can be used to generate a list of `Expr`.

module(AbsForms)

Equivalent to `module/3`.

module(AbsForms, FileName)

Equivalent to `module/3`.

module(AbsForms, FileName, CompileOptions)

Checks all the forms in a module for errors. It returns

# Types

Link to this type

# error_description()

View Source

    -type error_description() :: term().

Link to this type

# error_info()

View Source

    -type error_info() :: {erl_anno:location() | none, module(), error_description()}.

Link to this type

# fa()

View Source (not exported)

    -type fa() :: {atom(), arity()}.

Link to this type

# fun_used_vars()

View Source

    -type fun_used_vars() :: #{erl_parse:abstract_expr() => {[atom()], fun_used_vars()}}.

# Functions

Link to this function

# format_error(ErrorDescriptor)

View Source

    -spec format_error(ErrorDescriptor) -> io_lib:chars() when ErrorDescriptor :: error_description().

Takes an `ErrorDescriptor` and returns a string that describes the error or warning. This function is usually called implicitly when processing an `ErrorInfo` structure (see section Error Information).

Link to this function

# is_guard_test(Expr)

View Source

    -spec is_guard_test(Expr) -> boolean() when Expr :: erl_parse:abstract_expr().

Tests if `Expr` is a legal guard test. `Expr` is an Erlang term representing the abstract form for the expression. `erl_parse:parse_exprs(Tokens)` can be used to generate a list of `Expr`.

Link to this function

# module(AbsForms)

View Source

    -spec module(AbsForms) -> {ok, Warnings} | {error, Errors, Warnings}
                    when
                        AbsForms :: [erl_parse:abstract_form() | erl_parse:form_info()],
                        Warnings :: [{SourceFile, [ErrorInfo]}],
                        Errors :: [{SourceFile, [ErrorInfo]}],
                        SourceFile :: file:filename(),
                        ErrorInfo :: error_info().

Equivalent to `module/3`.

Link to this function

# module(AbsForms, FileName)

View Source

    -spec module(AbsForms, FileName) -> {ok, Warnings} | {error, Errors, Warnings}
                    when
                        AbsForms :: [erl_parse:abstract_form() | erl_parse:form_info()],
                        FileName :: atom() | string(),
                        Warnings :: [{SourceFile, [ErrorInfo]}],
                        Errors :: [{SourceFile, [ErrorInfo]}],
                        SourceFile :: file:filename(),
                        ErrorInfo :: error_info().

Equivalent to `module/3`.

Link to this function

# module(AbsForms, FileName, CompileOptions)

View Source

    -spec module(AbsForms, FileName, CompileOptions) -> {ok, Warnings} | {error, Errors, Warnings}
                    when
                        AbsForms :: [erl_parse:abstract_form() | erl_parse:form_info()],
                        FileName :: atom() | string(),
                        CompileOptions :: [compile:option()],
                        Warnings :: [{SourceFile, [ErrorInfo]}],
                        Errors :: [{SourceFile, [ErrorInfo]}],
                        SourceFile :: file:filename(),
                        ErrorInfo :: error_info().

Checks all the forms in a module for errors. It returns:

- `{ok,Warnings}` - There are no errors in the module.

- `{error,Errors,Warnings}` - There are errors in the module.

As this module is of interest only to the maintainers of the compiler, and to avoid the same description in two places, the elements of `Options` that control the warnings are only described in the `compile` module.

`AbsForms` of a module, which comes from a file that is read through `epp`, the Erlang preprocessor, can come from many files. This means that any references to errors must include the filename, see the `epp` module or parser (see the `erl_parse` module). The returned errors and warnings have the following format:

    [{SourceFile,[ErrorInfo]}]

The errors and warnings are listed in the order in which they are encountered in the forms. The errors from one file can therefore be split into different entries in the list of errors.